﻿using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using L = Simplicity.Utilities.Log;
using SB = Simplicity.Helpers.Spell_Book;
#endregion

namespace Simplicity.Core
{
    static class Unit
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        public static List<WoWUnit> Minions {get { return StyxWoW.Me.Minions; } }
        public static bool activeTotem(int desiredNumber)
        {
            if (Minions.Count == desiredNumber)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        
        #region [Method] - Active Enemies
        public static IEnumerable<WoWUnit> activeEnemies(WoWPoint fromLocation, double Range)
        {
            var Hostile = enemyCount;
            return Hostile != null ? Hostile.Where(x => x.Location.DistanceSqr(fromLocation) < Range * Range) : null;
        }

         public static List<WoWUnit> enemyCount { get; set; } //encapsulated list



        public static void enemyAnnex(double Range)
        {
            enemyCount.Clear();
            foreach (var u in surroundingEnemies()) //take every enemy within range, check conditions, add it or ignore it.
            {
                if (u == null || !u.IsValid)
                    continue;
                if (!u.IsAlive || u.DistanceSqr > Range * Range)
                    continue;
                if (!u.Attackable || !u.CanSelect)
                    continue;
                if (u.IsFriendly)
                    continue;
                if (u.IsNonCombatPet && u.IsCritter)
                    continue;
                if (u.BaseHealth < myHealth *.5) //removes trivial mobs which is any mob less than 50% of our health
                    continue;
                enemyCount.Add(u);
            }
        }

        private static IEnumerable<WoWUnit> surroundingEnemies() { return ObjectManager.GetObjectsOfTypeFast<WoWUnit>(); }
        //Units near me

        static Unit() { enemyCount = new List<WoWUnit>(); }  
        #endregion

        #region [Method] - Aura Detection

        public static uint auraStacks(this WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return 0;                
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
            return Aura != null ? Aura.StackCount : 0;
    }
    catch (Exception xException) {
    
        L.diagnosticLog("Exception in auraStacks(): ", xException);
        return 0;
    }
}  

        public static bool auraExists(this WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return false;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in auraExists(): ", xException);
                return false;
            }
        }
  
        public static double auraTimeLeft(this WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.TimeLeft.TotalMilliseconds : 0;
            }
            catch (Exception xException)
            {
        L.diagnosticLog("Exception in auraTimeLeft(): ", xException);
        return 9999;
    }
}  
        #endregion

        #region [Method] - Cache
        public static uint holyPower;
        public static uint energy;
        public static int comboPoints;
        public static uint myHealth;

        public static void Cache() //Sets static memory address for these variables. Decreases RAM usage by a lot.
        {
            holyPower = Me.CurrentHolyPower;
            energy = Me.CurrentEnergy;
            comboPoints = Me.ComboPoints;
            myHealth = Me.BaseHealth;
            
        }  
        #endregion

        #region [Method] - Unit Evaluation
        public static bool isUnitValid(this WoWUnit Unit, double Range)
        {
            return Unit != null && Unit.IsValid && Unit.IsAlive && Unit.Attackable && Unit.DistanceSqr <= Range * Range;
        }  
        #endregion


    }

    
}
