﻿using CommonBehaviors.Actions;
using Styx;
using Styx.CommonBot;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using Styx.WoWInternals;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
#region [Method] - Class Redundancy
using HkM = Simplicity.Managers.Hotkey_Manager;
using SB = Simplicity.Helpers.Spell_Book;
using TM = Simplicity.Managers.Talent_Manager;
using U = Simplicity.Core.Unit;
using S = Simplicity.Core.Spell;
#endregion  
namespace Simplicity.Rotation
{
    class EleShaman
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        #region [Method] - Combat Buffing
        public static Composite combatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed())
                //actions=rebuke
                //actions+=/potion,name=mogu_power,if=(buff.bloodlust.react|buff.avenging_wrath.up|target.time_to_die<=40)
                //actions+=/auto_attack
                //actions+=/speed_of_light,if=movement.distance>5
                //actions+=/execution_sentence
                //actions+=/lights_hammer
                //actions+=/holy_avenger,sync=seraphim,if=talent.seraphim.enabled
                //actions+=/holy_avenger,if=holy_power<=2&!talent.seraphim.enabled
                //actions+=/avenging_wrath,sync=seraphim,if=talent.seraphim.enabled
                //actions+=/avenging_wrath,if=!talent.seraphim.enabled
                //actions+=/blood_fury
                //actions+=/berserking
                //actions+=/arcane_torrent
                //actions+=/seraphim
                //actions+=/call_action_list,name=aoe,if=active_enemies>=5
                //actions+=/call_action_list,name=cleave,if=active_enemies>=3
                //actions+=/call_action_list,name=single

                );
        }
        #endregion

        #region [Method] - Precombat Buffing
        public static Composite preCombatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || Me.IsCasting || Me.IsChanneling || Me.Mounted || Me.OnTaxi, new ActionAlwaysSucceed()),
                    S.Buff(SB.LightningShield, ret => U.auraExists(Me, SB.LightningShield) == false || U.auraTimeLeft(Me, SB.LightningShield) <= 5)


                );
        }
        #endregion

        #region [Method] - Rotation Selector
        public static Composite rotationSelector()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed()),
                new Switch<bool>(ret => HkM.aoeOn,
                    new SwitchArgument<bool>(true,
                        new PrioritySelector(
                        S.Cast(SB.FireNova, ret => U.isUnitValid(currentTarget,5)),
                        S.Cast(SB.FlameShock, ret => U.isUnitValid(currentTarget,5) || U.auraTimeLeft(currentTarget, SB.FlameShock) <= 9), 
                        S.Cast(SB.LavaLash, ret => U.isUnitValid(currentTarget,5)),
                        S.Cast(SB.ChainLightning, ret => U.isUnitValid(currentTarget,20) && U.auraStacks(Me,SB.MaelstormWeapon) == 5),
                        S.blindCast(SB.MagmaTotem, ret => U.isUnitValid(currentTarget,10))

                            )),
                    new SwitchArgument<bool>(false,
                        new PrioritySelector(
                        S.Cast(SB.UnleashElements, ret => U.isUnitValid(currentTarget, 40)),
                        S.Cast(SB.LightningBolt, ret => U.isUnitValid(currentTarget, 40) && U.auraStacks(Me, SB.MaelstormWeapon) == 5),
                        S.Cast(SB.Stormstrike, ret => U.isUnitValid(currentTarget, 5)),
                        S.Cast(SB.LavaLash, ret => U.isUnitValid(currentTarget, 5)),
                        S.Cast(SB.FlameShock, ret => U.isUnitValid(currentTarget,15) && U.auraTimeLeft(currentTarget, SB.FlameShock) <= 9),
                        S.Cast(SB.FlameShock, ret=> U.isUnitValid(currentTarget,15)),
                        S.Cast(SB.Windstrike, ret => U.isUnitValid(currentTarget,5) && U.auraExists(Me, SB.Ascendance) == true),
                        S.Cast(SB.FeralSpirit, ret => U.isUnitValid(currentTarget,5) && currentTarget.IsBoss == true),
                        S.Cast(SB.Ascendance, ret => U.isUnitValid(currentTarget,5) && currentTarget.IsBoss == true),
                        S.blindCast(SB.SearingTotem, ret => U.isUnitValid(currentTarget,20) && U.activeTotem(1) == false),
                        S.blindCast(SB.FireElemental, ret => U.isUnitValid(currentTarget,20) && currentTarget.IsBoss == true)))));


                            
        }
    }
}
        #endregion