﻿using CommonBehaviors.Actions;
using Styx;
using Styx.CommonBot;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using Styx.WoWInternals;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
#region [Method] - Class Redundancy
using HkM = Simplicity.Managers.Hotkey_Manager;
using SB = Simplicity.Helpers.Spell_Book;
using TM = Simplicity.Managers.Talent_Manager;
using U = Simplicity.Core.Unit;
using S = Simplicity.Core.Spell;
#endregion
namespace Simplicity.Rotation
{
    class FeralDruid
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        #region [Method] - Combat Buffing
        public static Composite combatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed())
                //actions=rebuke
                //actions+=/potion,name=mogu_power,if=(buff.bloodlust.react|buff.avenging_wrath.up|target.time_to_die<=40)
                //actions+=/auto_attack
                //actions+=/speed_of_light,if=movement.distance>5
                //actions+=/execution_sentence
                //actions+=/lights_hammer
                //actions+=/holy_avenger,sync=seraphim,if=talent.seraphim.enabled
                //actions+=/holy_avenger,if=holy_power<=2&!talent.seraphim.enabled
                //actions+=/avenging_wrath,sync=seraphim,if=talent.seraphim.enabled
                //actions+=/avenging_wrath,if=!talent.seraphim.enabled
                //actions+=/blood_fury
                //actions+=/berserking
                //actions+=/arcane_torrent
                //actions+=/seraphim
                //actions+=/call_action_list,name=aoe,if=active_enemies>=5
                //actions+=/call_action_list,name=cleave,if=active_enemies>=3
                //actions+=/call_action_list,name=single

                );
        }
        #endregion

        #region [Method] - Precombat Buffing
        public static Composite preCombatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || Me.IsCasting || Me.IsChanneling || Me.Mounted || Me.OnTaxi, new ActionAlwaysSucceed()),
                    S.Buff(SB.CatForm, ret => U.auraExists(Me, SB.CatForm) == false)


                );
        }
        #endregion

        #region [Method] - Rotation Selector
        public static Composite rotationSelector()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed()),
                new Switch<bool>(ret => HkM.aoeOn,
                    new SwitchArgument<bool>(true,
                        new PrioritySelector(
                        S.Cast(SB.Thrash, ret => (U.isUnitValid(currentTarget,5))),
                        S.blindCast(SB.SavageRoar, ret => !(U.auraExists(Me, SB.SavageRoar))),
                        S.blindCast(SB.SavageRoar, ret => (U.auraTimeLeft(Me, SB.SavageRoar) < 3)

                            ))),
                    new SwitchArgument<bool>(false,
                        new PrioritySelector(
                        S.Cast(SB.Shred, ret => U.isUnitValid(currentTarget, 5) && U.comboPoints < 5),  
                        S.Cast(SB.Rake, ret => (U.isUnitValid(currentTarget,5) && !currentTarget.HasAura(SB.RakeAura))),
                        S.Cast(SB.Rake, ret => (U.isUnitValid(currentTarget,5) && U.auraTimeLeft(currentTarget, SB.RakeAura) < 4)),
                        S.Cast(SB.Rake, ret => (U.isUnitValid(currentTarget,5)) && U.comboPoints < 5),
                        S.blindCast(SB.SavageRoar, ret => !(Me.HasAura(SB.SavageRoar)) || (U.auraTimeLeft(Me, SB.SavageRoar) < 3)),
                        S.Cast(SB.Rip, ret => (U.isUnitValid(currentTarget,5) && Me.CurrentTarget.HealthPercent > 25 && U.comboPoints == 5)),
                        S.Cast(SB.Rip, ret => (U.isUnitValid(currentTarget,5) && U.auraTimeLeft(currentTarget, SB.Rip) < 7)),
                        S.Cast(SB.FerociousBite, ret => (U.isUnitValid(currentTarget, 5) && Me.CurrentTarget.HealthPercent < 25 && U.comboPoints == 5)),
                        S.Cast(SB.FerociousBite, ret => (U.isUnitValid(currentTarget, 5) && U.energy >= 50 && Me.CurrentTarget.HealthPercent > 25 && U.comboPoints == 5 && U.auraTimeLeft(currentTarget, SB.Rip) > 3 && U.auraTimeLeft(Me, SB.SavageRoar) > 3)),
                        S.Cast(SB.FerociousBite, ret => (U.isUnitValid(currentTarget, 5) && U.comboPoints == 5)),
                        S.blindCast(SB.StrongCat, ret => (Me.CurrentTarget.IsBoss)),
                        S.blindCast(SB.TigersFury, ret => U.energy <= 40 && Me.Combat == true),
                        S.blindCast(SB.Berserk, ret => (Me.CurrentTarget.IsBoss)),
                        S.blindCast(SB.CatForm, ret => !(U.auraExists(Me, SB.CatForm))),
                        S.Cast(SB.Thrash, ret => (U.isUnitValid(currentTarget, 5)) && U.auraExists(Me,SB.OmenofClarity))

                        ))));



        }
    }
}
        #endregion