﻿using CommonBehaviors.Actions;
using Styx;
using Styx.CommonBot;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using Styx.WoWInternals;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
#region [Method] - Class Redundancy
using HkM = Simplicity.Managers.Hotkey_Manager;
using SB = Simplicity.Helpers.Spell_Book;
using TM = Simplicity.Managers.Talent_Manager;
using U = Simplicity.Core.Unit;
using S = Simplicity.Core.Spell;
#endregion  
namespace Simplicity.Rotation
{
    class Rotation
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        #region [Method] - Combat Buffing
        public static Composite combatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed())
                //actions=rebuke
                //actions+=/potion,name=mogu_power,if=(buff.bloodlust.react|buff.avenging_wrath.up|target.time_to_die<=40)
                //actions+=/auto_attack
                //actions+=/speed_of_light,if=movement.distance>5
                //actions+=/execution_sentence
                //actions+=/lights_hammer
                //actions+=/holy_avenger,sync=seraphim,if=talent.seraphim.enabled
                //actions+=/holy_avenger,if=holy_power<=2&!talent.seraphim.enabled
                //actions+=/avenging_wrath,sync=seraphim,if=talent.seraphim.enabled
                //actions+=/avenging_wrath,if=!talent.seraphim.enabled
                //actions+=/blood_fury
                //actions+=/berserking
                //actions+=/arcane_torrent
                //actions+=/seraphim
                //actions+=/call_action_list,name=aoe,if=active_enemies>=5
                //actions+=/call_action_list,name=cleave,if=active_enemies>=3
                //actions+=/call_action_list,name=single

                );
        }
        #endregion

        #region [Method] - Precombat Buffing
        public static Composite preCombatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || Me.IsCasting || Me.IsChanneling || Me.Mounted || Me.OnTaxi, new ActionAlwaysSucceed()),
                S.blindCast(SB.SealofTruth, ret => !U.auraExists(Me, SB.SealofTruth, true))
        );

                
        }
        #endregion

        #region [Method] - Rotation Selector
        public static Composite rotationSelector()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed()),
                new Switch<bool>(ret => HkM.aoeOn,
                    new SwitchArgument<bool>(true,
                        new PrioritySelector(
                        S.Cast(SB.HammeroftheRighteous, ret => U.isUnitValid(currentTarget,5) && U.holyPower < 5),
                        S.Cast(SB.Judgment, ret => U.isUnitValid(currentTarget, 30) && U.holyPower < 5),
                        S.Cast(SB.Exorcism, ret => U.isUnitValid(currentTarget, 30) && U.holyPower < 5),
                        S.Cast(SB.HammerofWrath, ret => U.isUnitValid(currentTarget, 30) && currentTarget.HealthPercent <= 35),
                        S.Cast(SB.HammerofWrath, ret => U.isUnitValid(currentTarget, 30) && U.auraExists(Me, SB.AvengingWrath)),
                        S.Cast(SB.HammerofWrath, ret => U.isUnitValid(currentTarget, 30) && S.cooldownTimeLeft(SB.HammerofWrath) <= 1500),
                        S.Cast(SB.DivineStorm, ret => U.isUnitValid(currentTarget, 5) && U.holyPower == 5),
                        S.Cast(SB.DivineStorm, ret => U.isUnitValid(currentTarget, 5) && U.holyPower >= 3 && S.cooldownTimeLeft(SB.HammeroftheRighteous) >= 1000 && S.cooldownTimeLeft(SB.Judgment) >= 1000 &&
                        S.cooldownTimeLeft(SB.Exorcism) >= 1000),
                        S.Cast(SB.ExecutionSentence, ret => U.isUnitValid(currentTarget, 40)),
                        S.blindCast(SB.AvengingWrath, ret => currentTarget.IsBoss && currentTarget.IsHostile),
                        S.blindCast(SB.AvengingWrath, ret => currentTarget.BaseHealth > Me.BaseHealth * 10 && currentTarget.IsHostile)

                            )),
                    new SwitchArgument<bool>(false,
                        new PrioritySelector(
                        S.Cast(SB.CrusaderStrike, ret => U.isUnitValid(currentTarget,5) && U.holyPower < 5, true),
                        S.Cast(SB.Judgment, ret => U.isUnitValid(currentTarget, 30) && U.holyPower < 5, true),
                        S.Cast(SB.Exorcism, ret => U.isUnitValid(currentTarget, 30) && U.holyPower < 5, true),
                        S.Cast(SB.HammerofWrath, ret => U.isUnitValid(currentTarget, 30) && currentTarget.HealthPercent <= 35, true),
                        S.Cast(SB.HammerofWrath, ret => U.isUnitValid(currentTarget, 30) && U.auraExists(Me, SB.AvengingWrath), true),
                        S.Cast(SB.HammerofWrath, ret => U.isUnitValid(currentTarget, 30) && S.cooldownTimeLeft(SB.HammerofWrath) <= 1500 && U.holyPower != 5, true),
                        S.Cast(SB.TemplarsVerdict, ret => U.isUnitValid(currentTarget, 5) && TM.finalVerdict == false && U.holyPower == 5, true),
                        S.Cast(SB.TemplarsVerdict, ret => U.isUnitValid(currentTarget, 5) && TM.finalVerdict == false && U.holyPower >= 3 && S.cooldownTimeLeft(SB.CrusaderStrike) >= 1500 && 
                        S.cooldownTimeLeft(SB.Judgment) >= 1500 && S.cooldownTimeLeft(SB.Exorcism) >= 1500, true),
                        S.blindCast(SB.DivineStorm, ret => U.auraExists(Me, SB.DivineCrusader), true),
                        S.Cast(SB.ExecutionSentence, ret => U.isUnitValid(currentTarget, 40), true),
                        S.blindCast(SB.AvengingWrath, ret => currentTarget.IsBoss && currentTarget.IsHostile, true),
                        S.blindCast(SB.AvengingWrath, ret => currentTarget.BaseHealth > Me.BaseHealth * 10 && currentTarget.IsHostile, true )


                            ))));
        }
        #endregion


    }
}
