﻿using CommonBehaviors.Actions;
using Styx;
using Styx.CommonBot;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using Styx.WoWInternals;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
#region [Method] - Class Redundancy
using HkM = Simplicity.Managers.Hotkey_Manager;
using SB = Simplicity.Helpers.Spell_Book;
using TM = Simplicity.Managers.Talent_Manager;
using U = Simplicity.Core.Unit;
using S = Simplicity.Core.Spell;
#endregion
namespace Simplicity.Rotation
{
    class TankDruid
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        #region [Method] - Combat Buffing
        public static Composite combatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed())
                //actions=rebuke
                //actions+=/potion,name=mogu_power,if=(buff.bloodlust.react|buff.avenging_wrath.up|target.time_to_die<=40)
                //actions+=/auto_attack
                //actions+=/speed_of_light,if=movement.distance>5
                //actions+=/execution_sentence
                //actions+=/lights_hammer
                //actions+=/holy_avenger,sync=seraphim,if=talent.seraphim.enabled
                //actions+=/holy_avenger,if=holy_power<=2&!talent.seraphim.enabled
                //actions+=/avenging_wrath,sync=seraphim,if=talent.seraphim.enabled
                //actions+=/avenging_wrath,if=!talent.seraphim.enabled
                //actions+=/blood_fury
                //actions+=/berserking
                //actions+=/arcane_torrent
                //actions+=/seraphim
                //actions+=/call_action_list,name=aoe,if=active_enemies>=5
                //actions+=/call_action_list,name=cleave,if=active_enemies>=3
                //actions+=/call_action_list,name=single

                );
        }
        #endregion

        #region [Method] - Precombat Buffing
        public static Composite preCombatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || Me.IsCasting || Me.IsChanneling || Me.Mounted || Me.OnTaxi, new ActionAlwaysSucceed()),
                    S.Buff(SB.BearForm, ret => U.auraExists(Me, SB.BearForm) == false)


                );
        }
        #endregion

        #region [Method] - Rotation Selector
        public static Composite rotationSelector()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed()),
                new Switch<bool>(ret => HkM.aoeOn,
                    new SwitchArgument<bool>(true,
                        new PrioritySelector(
                        S.Cast(SB.Thrash, ret => (U.isUnitValid(currentTarget, 5))),
                        S.blindCast(SB.SavageRoar, ret => !(U.auraExists(Me, SB.SavageRoar))),
                        S.blindCast(SB.SavageRoar, ret => (U.auraTimeLeft(Me, SB.SavageRoar) < 3)

                            ))),
                    new SwitchArgument<bool>(false,
                        new PrioritySelector(
                        S.Cast(SB.Mangle, ret => (U.isUnitValid(currentTarget,5))),
                        S.Cast(SB.Lacerate, ret => (U.isUnitValid(currentTarget,5) && U.auraStacks(currentTarget,SB.Lacerate) < 3)),
                        S.Cast(SB.Pulverize, ret => (U.isUnitValid(currentTarget,5) && U.auraStacks(currentTarget,SB.Lacerate) >= 1)),
                        S.Cast(SB.Thrash, ret => (U.isUnitValid(currentTarget,5) && !U.auraExists(currentTarget,SB.Thrash))),
                        S.Cast(SB.Thrash, ret => (U.isUnitValid(currentTarget,5) && U.auraTimeLeft(currentTarget,SB.Thrash) >= 4)),
                        S.Cast(SB.Maul, ret => (U.isUnitValid(currentTarget,5) && U.auraExists(Me,SB.ToothAndClaw))),
                        S.Cast(SB.Maul, ret => (U.isUnitValid(currentTarget,5) && Me.CurrentRage >= 85 && Me.HealthPercent >= 90))


                        ))));



        }
    }
}
        #endregion